/* ide-vala-locator.c generated by valac 0.42.3, the Vala compiler
 * generated from ide-vala-locator.vala, do not modify */

/*
 * Copyright © 2008 Abderrahim Kitouni
 * Copyright © 2015 Christian Hergert <christian@hergert.me>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
/* Finds the innermost block containing the given location */


#include <glib.h>
#include <glib-object.h>
#include <vala.h>
#include <valagee.h>
#include <string.h>


#define IDE_TYPE_VALA_LOCATOR (ide_vala_locator_get_type ())
#define IDE_VALA_LOCATOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), IDE_TYPE_VALA_LOCATOR, IdeValaLocator))
#define IDE_VALA_LOCATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), IDE_TYPE_VALA_LOCATOR, IdeValaLocatorClass))
#define IDE_IS_VALA_LOCATOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), IDE_TYPE_VALA_LOCATOR))
#define IDE_IS_VALA_LOCATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), IDE_TYPE_VALA_LOCATOR))
#define IDE_VALA_LOCATOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), IDE_TYPE_VALA_LOCATOR, IdeValaLocatorClass))

typedef struct _IdeValaLocator IdeValaLocator;
typedef struct _IdeValaLocatorClass IdeValaLocatorClass;
typedef struct _IdeValaLocatorPrivate IdeValaLocatorPrivate;

#define IDE_VALA_LOCATOR_TYPE_LOCATION (ide_vala_locator_location_get_type ())
typedef struct _IdeValaLocatorLocation IdeValaLocatorLocation;
#define _vala_code_node_unref0(var) ((var == NULL) ? NULL : (var = (vala_code_node_unref (var), NULL)))
#define _vala_iterable_unref0(var) ((var == NULL) ? NULL : (var = (vala_iterable_unref (var), NULL)))

struct _IdeValaLocator {
	ValaCodeVisitor parent_instance;
	IdeValaLocatorPrivate * priv;
};

struct _IdeValaLocatorClass {
	ValaCodeVisitorClass parent_class;
};

struct _IdeValaLocatorLocation {
	gint line;
	gint column;
};

struct _IdeValaLocatorPrivate {
	IdeValaLocatorLocation location;
	ValaSymbol* innermost;
	IdeValaLocatorLocation innermost_begin;
	IdeValaLocatorLocation innermost_end;
};


static gint IdeValaLocator_private_offset;
static gpointer ide_vala_locator_parent_class = NULL;
static GType ide_vala_locator_type_id = 0;

GType ide_vala_locator_register_type (GTypeModule * module);
GType ide_vala_locator_get_type (void) G_GNUC_CONST;
static GType ide_vala_locator_location_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
static IdeValaLocatorLocation* ide_vala_locator_location_dup (const IdeValaLocatorLocation* self);
static void ide_vala_locator_location_free (IdeValaLocatorLocation* self);
ValaSymbol* ide_vala_locator_locate (IdeValaLocator* self,
                                     ValaSourceFile* file,
                                     gint line,
                                     gint column);
static void ide_vala_locator_location_init (IdeValaLocatorLocation *self,
                                     gint line,
                                     gint column);
static gboolean ide_vala_locator_update_location (IdeValaLocator* self,
                                           ValaSymbol* s);
static gboolean ide_vala_locator_location_inside (IdeValaLocatorLocation *self,
                                           ValaSourceReference* src);
static gboolean ide_vala_locator_location_before (IdeValaLocatorLocation *self,
                                           IdeValaLocatorLocation* other);
static void ide_vala_locator_real_visit_block (ValaCodeVisitor* base,
                                        ValaBlock* b);
static void ide_vala_locator_real_visit_namespace (ValaCodeVisitor* base,
                                            ValaNamespace* ns);
static void ide_vala_locator_real_visit_class (ValaCodeVisitor* base,
                                        ValaClass* cl);
static void ide_vala_locator_real_visit_struct (ValaCodeVisitor* base,
                                         ValaStruct* st);
static void ide_vala_locator_real_visit_interface (ValaCodeVisitor* base,
                                            ValaInterface* iface);
static void ide_vala_locator_real_visit_method (ValaCodeVisitor* base,
                                         ValaMethod* m);
static void ide_vala_locator_real_visit_creation_method (ValaCodeVisitor* base,
                                                  ValaCreationMethod* m);
static void ide_vala_locator_real_visit_property (ValaCodeVisitor* base,
                                           ValaProperty* prop);
static void ide_vala_locator_real_visit_property_accessor (ValaCodeVisitor* base,
                                                    ValaPropertyAccessor* acc);
static void ide_vala_locator_real_visit_constructor (ValaCodeVisitor* base,
                                              ValaConstructor* c);
static void ide_vala_locator_real_visit_destructor (ValaCodeVisitor* base,
                                             ValaDestructor* d);
static void ide_vala_locator_real_visit_if_statement (ValaCodeVisitor* base,
                                               ValaIfStatement* stmt);
static void ide_vala_locator_real_visit_switch_statement (ValaCodeVisitor* base,
                                                   ValaSwitchStatement* stmt);
static void ide_vala_locator_real_visit_switch_section (ValaCodeVisitor* base,
                                                 ValaSwitchSection* section);
static void ide_vala_locator_real_visit_while_statement (ValaCodeVisitor* base,
                                                  ValaWhileStatement* stmt);
static void ide_vala_locator_real_visit_do_statement (ValaCodeVisitor* base,
                                               ValaDoStatement* stmt);
static void ide_vala_locator_real_visit_for_statement (ValaCodeVisitor* base,
                                                ValaForStatement* stmt);
static void ide_vala_locator_real_visit_foreach_statement (ValaCodeVisitor* base,
                                                    ValaForeachStatement* stmt);
static void ide_vala_locator_real_visit_try_statement (ValaCodeVisitor* base,
                                                ValaTryStatement* stmt);
static void ide_vala_locator_real_visit_catch_clause (ValaCodeVisitor* base,
                                               ValaCatchClause* clause);
static void ide_vala_locator_real_visit_lock_statement (ValaCodeVisitor* base,
                                                 ValaLockStatement* stmt);
static void ide_vala_locator_real_visit_expression_statement (ValaCodeVisitor* base,
                                                       ValaExpressionStatement* stmt);
static void ide_vala_locator_real_visit_declaration_statement (ValaCodeVisitor* base,
                                                        ValaDeclarationStatement* stmt);
static void ide_vala_locator_real_visit_local_variable (ValaCodeVisitor* base,
                                                 ValaLocalVariable* variable);
static void ide_vala_locator_real_visit_end_full_expression (ValaCodeVisitor* base,
                                                      ValaExpression* expr);
static void ide_vala_locator_real_visit_expression (ValaCodeVisitor* base,
                                             ValaExpression* expr);
IdeValaLocator* ide_vala_locator_new (void);
IdeValaLocator* ide_vala_locator_construct (GType object_type);
static void ide_vala_locator_finalize (ValaCodeVisitor * obj);


static inline gpointer
ide_vala_locator_get_instance_private (IdeValaLocator* self)
{
	return G_STRUCT_MEMBER_P (self, IdeValaLocator_private_offset);
}


static gpointer
_vala_code_node_ref0 (gpointer self)
{
#line 56 "../src/plugins/vala-pack/ide-vala-locator.vala"
	return self ? vala_code_node_ref (self) : NULL;
#line 161 "ide-vala-locator.c"
}


ValaSymbol*
ide_vala_locator_locate (IdeValaLocator* self,
                         ValaSourceFile* file,
                         gint line,
                         gint column)
{
	ValaSymbol* result = NULL;
	ValaSymbol* _tmp0_;
	ValaSymbol* _tmp1_;
#line 52 "../src/plugins/vala-pack/ide-vala-locator.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 52 "../src/plugins/vala-pack/ide-vala-locator.vala"
	g_return_val_if_fail (file != NULL, NULL);
#line 53 "../src/plugins/vala-pack/ide-vala-locator.vala"
	ide_vala_locator_location_init (&self->priv->location, line, column);
#line 54 "../src/plugins/vala-pack/ide-vala-locator.vala"
	_vala_code_node_unref0 (self->priv->innermost);
#line 54 "../src/plugins/vala-pack/ide-vala-locator.vala"
	self->priv->innermost = NULL;
#line 55 "../src/plugins/vala-pack/ide-vala-locator.vala"
	vala_source_file_accept_children (file, (ValaCodeVisitor*) self);
#line 56 "../src/plugins/vala-pack/ide-vala-locator.vala"
	_tmp0_ = self->priv->innermost;
#line 56 "../src/plugins/vala-pack/ide-vala-locator.vala"
	_tmp1_ = _vala_code_node_ref0 (_tmp0_);
#line 56 "../src/plugins/vala-pack/ide-vala-locator.vala"
	result = _tmp1_;
#line 56 "../src/plugins/vala-pack/ide-vala-locator.vala"
	return result;
#line 194 "ide-vala-locator.c"
}


static gboolean
ide_vala_locator_update_location (IdeValaLocator* self,
                                  ValaSymbol* s)
{
	gboolean result = FALSE;
	ValaSourceReference* _tmp0_;
	ValaSourceReference* _tmp1_;
	IdeValaLocatorLocation begin = {0};
	ValaSourceReference* _tmp2_;
	ValaSourceReference* _tmp3_;
	ValaSourceLocation _tmp4_ = {0};
	ValaSourceLocation _tmp5_;
	gint _tmp6_;
	ValaSourceReference* _tmp7_;
	ValaSourceReference* _tmp8_;
	ValaSourceLocation _tmp9_ = {0};
	ValaSourceLocation _tmp10_;
	gint _tmp11_;
	IdeValaLocatorLocation end = {0};
	ValaSourceReference* _tmp12_;
	ValaSourceReference* _tmp13_;
	ValaSourceLocation _tmp14_ = {0};
	ValaSourceLocation _tmp15_;
	gint _tmp16_;
	ValaSourceReference* _tmp17_;
	ValaSourceReference* _tmp18_;
	ValaSourceLocation _tmp19_ = {0};
	ValaSourceLocation _tmp20_;
	gint _tmp21_;
	gboolean _tmp22_ = FALSE;
	ValaSymbol* _tmp23_;
#line 59 "../src/plugins/vala-pack/ide-vala-locator.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 59 "../src/plugins/vala-pack/ide-vala-locator.vala"
	g_return_val_if_fail (s != NULL, FALSE);
#line 60 "../src/plugins/vala-pack/ide-vala-locator.vala"
	_tmp0_ = vala_code_node_get_source_reference ((ValaCodeNode*) s);
#line 60 "../src/plugins/vala-pack/ide-vala-locator.vala"
	_tmp1_ = _tmp0_;
#line 60 "../src/plugins/vala-pack/ide-vala-locator.vala"
	if (!ide_vala_locator_location_inside (&self->priv->location, _tmp1_)) {
#line 61 "../src/plugins/vala-pack/ide-vala-locator.vala"
		result = FALSE;
#line 61 "../src/plugins/vala-pack/ide-vala-locator.vala"
		return result;
#line 243 "ide-vala-locator.c"
	}
#line 63 "../src/plugins/vala-pack/ide-vala-locator.vala"
	_tmp2_ = vala_code_node_get_source_reference ((ValaCodeNode*) s);
#line 63 "../src/plugins/vala-pack/ide-vala-locator.vala"
	_tmp3_ = _tmp2_;
#line 63 "../src/plugins/vala-pack/ide-vala-locator.vala"
	vala_source_reference_get_begin (_tmp3_, &_tmp4_);
#line 63 "../src/plugins/vala-pack/ide-vala-locator.vala"
	_tmp5_ = _tmp4_;
#line 63 "../src/plugins/vala-pack/ide-vala-locator.vala"
	_tmp6_ = _tmp5_.line;
#line 63 "../src/plugins/vala-pack/ide-vala-locator.vala"
	_tmp7_ = vala_code_node_get_source_reference ((ValaCodeNode*) s);
#line 63 "../src/plugins/vala-pack/ide-vala-locator.vala"
	_tmp8_ = _tmp7_;
#line 63 "../src/plugins/vala-pack/ide-vala-locator.vala"
	vala_source_reference_get_begin (_tmp8_, &_tmp9_);
#line 63 "../src/plugins/vala-pack/ide-vala-locator.vala"
	_tmp10_ = _tmp9_;
#line 63 "../src/plugins/vala-pack/ide-vala-locator.vala"
	_tmp11_ = _tmp10_.column;
#line 63 "../src/plugins/vala-pack/ide-vala-locator.vala"
	ide_vala_locator_location_init (&begin, _tmp6_, _tmp11_);
#line 64 "../src/plugins/vala-pack/ide-vala-locator.vala"
	_tmp12_ = vala_code_node_get_source_reference ((ValaCodeNode*) s);
#line 64 "../src/plugins/vala-pack/ide-vala-locator.vala"
	_tmp13_ = _tmp12_;
#line 64 "../src/plugins/vala-pack/ide-vala-locator.vala"
	vala_source_reference_get_end (_tmp13_, &_tmp14_);
#line 64 "../src/plugins/vala-pack/ide-vala-locator.vala"
	_tmp15_ = _tmp14_;
#line 64 "../src/plugins/vala-pack/ide-vala-locator.vala"
	_tmp16_ = _tmp15_.line;
#line 64 "../src/plugins/vala-pack/ide-vala-locator.vala"
	_tmp17_ = vala_code_node_get_source_reference ((ValaCodeNode*) s);
#line 64 "../src/plugins/vala-pack/ide-vala-locator.vala"
	_tmp18_ = _tmp17_;
#line 64 "../src/plugins/vala-pack/ide-vala-locator.vala"
	vala_source_reference_get_end (_tmp18_, &_tmp19_);
#line 64 "../src/plugins/vala-pack/ide-vala-locator.vala"
	_tmp20_ = _tmp19_;
#line 64 "../src/plugins/vala-pack/ide-vala-locator.vala"
	_tmp21_ = _tmp20_.column;
#line 64 "../src/plugins/vala-pack/ide-vala-locator.vala"
	ide_vala_locator_location_init (&end, _tmp16_, _tmp21_);
#line 66 "../src/plugins/vala-pack/ide-vala-locator.vala"
	_tmp23_ = self->priv->innermost;
#line 66 "../src/plugins/vala-pack/ide-vala-locator.vala"
	if (_tmp23_ == NULL) {
#line 66 "../src/plugins/vala-pack/ide-vala-locator.vala"
		_tmp22_ = TRUE;
#line 295 "ide-vala-locator.c"
	} else {
		gboolean _tmp24_ = FALSE;
		IdeValaLocatorLocation _tmp25_;
#line 66 "../src/plugins/vala-pack/ide-vala-locator.vala"
		_tmp25_ = begin;
#line 66 "../src/plugins/vala-pack/ide-vala-locator.vala"
		if (ide_vala_locator_location_before (&self->priv->innermost_begin, &_tmp25_)) {
#line 303 "ide-vala-locator.c"
			IdeValaLocatorLocation _tmp26_;
#line 66 "../src/plugins/vala-pack/ide-vala-locator.vala"
			_tmp26_ = self->priv->innermost_end;
#line 66 "../src/plugins/vala-pack/ide-vala-locator.vala"
			_tmp24_ = ide_vala_locator_location_before (&end, &_tmp26_);
#line 309 "ide-vala-locator.c"
		} else {
#line 66 "../src/plugins/vala-pack/ide-vala-locator.vala"
			_tmp24_ = FALSE;
#line 313 "ide-vala-locator.c"
		}
#line 66 "../src/plugins/vala-pack/ide-vala-locator.vala"
		_tmp22_ = _tmp24_;
#line 317 "ide-vala-locator.c"
	}
#line 66 "../src/plugins/vala-pack/ide-vala-locator.vala"
	if (_tmp22_) {
#line 321 "ide-vala-locator.c"
		ValaSymbol* _tmp27_;
		IdeValaLocatorLocation _tmp28_;
		IdeValaLocatorLocation _tmp29_;
#line 67 "../src/plugins/vala-pack/ide-vala-locator.vala"
		_tmp27_ = _vala_code_node_ref0 (s);
#line 67 "../src/plugins/vala-pack/ide-vala-locator.vala"
		_vala_code_node_unref0 (self->priv->innermost);
#line 67 "../src/plugins/vala-pack/ide-vala-locator.vala"
		self->priv->innermost = _tmp27_;
#line 68 "../src/plugins/vala-pack/ide-vala-locator.vala"
		_tmp28_ = begin;
#line 68 "../src/plugins/vala-pack/ide-vala-locator.vala"
		self->priv->innermost_begin = _tmp28_;
#line 69 "../src/plugins/vala-pack/ide-vala-locator.vala"
		_tmp29_ = end;
#line 69 "../src/plugins/vala-pack/ide-vala-locator.vala"
		self->priv->innermost_end = _tmp29_;
#line 70 "../src/plugins/vala-pack/ide-vala-locator.vala"
		result = TRUE;
#line 70 "../src/plugins/vala-pack/ide-vala-locator.vala"
		return result;
#line 343 "ide-vala-locator.c"
	}
#line 73 "../src/plugins/vala-pack/ide-vala-locator.vala"
	result = FALSE;
#line 73 "../src/plugins/vala-pack/ide-vala-locator.vala"
	return result;
#line 349 "ide-vala-locator.c"
}


static void
ide_vala_locator_real_visit_block (ValaCodeVisitor* base,
                                   ValaBlock* b)
{
	IdeValaLocator * self;
#line 76 "../src/plugins/vala-pack/ide-vala-locator.vala"
	self = (IdeValaLocator*) base;
#line 76 "../src/plugins/vala-pack/ide-vala-locator.vala"
	g_return_if_fail (b != NULL);
#line 77 "../src/plugins/vala-pack/ide-vala-locator.vala"
	if (ide_vala_locator_update_location (self, (ValaSymbol*) b)) {
#line 78 "../src/plugins/vala-pack/ide-vala-locator.vala"
		vala_code_node_accept_children ((ValaCodeNode*) b, (ValaCodeVisitor*) self);
#line 366 "ide-vala-locator.c"
	}
}


static void
ide_vala_locator_real_visit_namespace (ValaCodeVisitor* base,
                                       ValaNamespace* ns)
{
	IdeValaLocator * self;
#line 81 "../src/plugins/vala-pack/ide-vala-locator.vala"
	self = (IdeValaLocator*) base;
#line 81 "../src/plugins/vala-pack/ide-vala-locator.vala"
	g_return_if_fail (ns != NULL);
#line 82 "../src/plugins/vala-pack/ide-vala-locator.vala"
	ide_vala_locator_update_location (self, (ValaSymbol*) ns);
#line 83 "../src/plugins/vala-pack/ide-vala-locator.vala"
	vala_code_node_accept_children ((ValaCodeNode*) ns, (ValaCodeVisitor*) self);
#line 384 "ide-vala-locator.c"
}


static void
ide_vala_locator_real_visit_class (ValaCodeVisitor* base,
                                   ValaClass* cl)
{
	IdeValaLocator * self;
#line 85 "../src/plugins/vala-pack/ide-vala-locator.vala"
	self = (IdeValaLocator*) base;
#line 85 "../src/plugins/vala-pack/ide-vala-locator.vala"
	g_return_if_fail (cl != NULL);
#line 87 "../src/plugins/vala-pack/ide-vala-locator.vala"
	if (ide_vala_locator_update_location (self, (ValaSymbol*) cl)) {
#line 88 "../src/plugins/vala-pack/ide-vala-locator.vala"
		return;
#line 401 "ide-vala-locator.c"
	}
#line 89 "../src/plugins/vala-pack/ide-vala-locator.vala"
	vala_code_node_accept_children ((ValaCodeNode*) cl, (ValaCodeVisitor*) self);
#line 405 "ide-vala-locator.c"
}


static void
ide_vala_locator_real_visit_struct (ValaCodeVisitor* base,
                                    ValaStruct* st)
{
	IdeValaLocator * self;
#line 91 "../src/plugins/vala-pack/ide-vala-locator.vala"
	self = (IdeValaLocator*) base;
#line 91 "../src/plugins/vala-pack/ide-vala-locator.vala"
	g_return_if_fail (st != NULL);
#line 92 "../src/plugins/vala-pack/ide-vala-locator.vala"
	if (ide_vala_locator_update_location (self, (ValaSymbol*) st)) {
#line 93 "../src/plugins/vala-pack/ide-vala-locator.vala"
		return;
#line 422 "ide-vala-locator.c"
	}
#line 94 "../src/plugins/vala-pack/ide-vala-locator.vala"
	vala_code_node_accept_children ((ValaCodeNode*) st, (ValaCodeVisitor*) self);
#line 426 "ide-vala-locator.c"
}


static void
ide_vala_locator_real_visit_interface (ValaCodeVisitor* base,
                                       ValaInterface* iface)
{
	IdeValaLocator * self;
#line 96 "../src/plugins/vala-pack/ide-vala-locator.vala"
	self = (IdeValaLocator*) base;
#line 96 "../src/plugins/vala-pack/ide-vala-locator.vala"
	g_return_if_fail (iface != NULL);
#line 97 "../src/plugins/vala-pack/ide-vala-locator.vala"
	if (ide_vala_locator_update_location (self, (ValaSymbol*) iface)) {
#line 98 "../src/plugins/vala-pack/ide-vala-locator.vala"
		return;
#line 443 "ide-vala-locator.c"
	}
#line 99 "../src/plugins/vala-pack/ide-vala-locator.vala"
	vala_code_node_accept_children ((ValaCodeNode*) iface, (ValaCodeVisitor*) self);
#line 447 "ide-vala-locator.c"
}


static void
ide_vala_locator_real_visit_method (ValaCodeVisitor* base,
                                    ValaMethod* m)
{
	IdeValaLocator * self;
#line 102 "../src/plugins/vala-pack/ide-vala-locator.vala"
	self = (IdeValaLocator*) base;
#line 102 "../src/plugins/vala-pack/ide-vala-locator.vala"
	g_return_if_fail (m != NULL);
#line 103 "../src/plugins/vala-pack/ide-vala-locator.vala"
	if (ide_vala_locator_update_location (self, (ValaSymbol*) m)) {
#line 104 "../src/plugins/vala-pack/ide-vala-locator.vala"
		return;
#line 464 "ide-vala-locator.c"
	}
#line 105 "../src/plugins/vala-pack/ide-vala-locator.vala"
	vala_code_node_accept_children ((ValaCodeNode*) m, (ValaCodeVisitor*) self);
#line 468 "ide-vala-locator.c"
}


static void
ide_vala_locator_real_visit_creation_method (ValaCodeVisitor* base,
                                             ValaCreationMethod* m)
{
	IdeValaLocator * self;
#line 107 "../src/plugins/vala-pack/ide-vala-locator.vala"
	self = (IdeValaLocator*) base;
#line 107 "../src/plugins/vala-pack/ide-vala-locator.vala"
	g_return_if_fail (m != NULL);
#line 108 "../src/plugins/vala-pack/ide-vala-locator.vala"
	if (ide_vala_locator_update_location (self, (ValaSymbol*) m)) {
#line 109 "../src/plugins/vala-pack/ide-vala-locator.vala"
		return;
#line 485 "ide-vala-locator.c"
	}
#line 110 "../src/plugins/vala-pack/ide-vala-locator.vala"
	vala_code_node_accept_children ((ValaCodeNode*) m, (ValaCodeVisitor*) self);
#line 489 "ide-vala-locator.c"
}


static void
ide_vala_locator_real_visit_property (ValaCodeVisitor* base,
                                      ValaProperty* prop)
{
	IdeValaLocator * self;
#line 112 "../src/plugins/vala-pack/ide-vala-locator.vala"
	self = (IdeValaLocator*) base;
#line 112 "../src/plugins/vala-pack/ide-vala-locator.vala"
	g_return_if_fail (prop != NULL);
#line 113 "../src/plugins/vala-pack/ide-vala-locator.vala"
	vala_code_node_accept_children ((ValaCodeNode*) prop, (ValaCodeVisitor*) self);
#line 504 "ide-vala-locator.c"
}


static void
ide_vala_locator_real_visit_property_accessor (ValaCodeVisitor* base,
                                               ValaPropertyAccessor* acc)
{
	IdeValaLocator * self;
#line 115 "../src/plugins/vala-pack/ide-vala-locator.vala"
	self = (IdeValaLocator*) base;
#line 115 "../src/plugins/vala-pack/ide-vala-locator.vala"
	g_return_if_fail (acc != NULL);
#line 116 "../src/plugins/vala-pack/ide-vala-locator.vala"
	vala_code_node_accept_children ((ValaCodeNode*) acc, (ValaCodeVisitor*) self);
#line 519 "ide-vala-locator.c"
}


static void
ide_vala_locator_real_visit_constructor (ValaCodeVisitor* base,
                                         ValaConstructor* c)
{
	IdeValaLocator * self;
#line 118 "../src/plugins/vala-pack/ide-vala-locator.vala"
	self = (IdeValaLocator*) base;
#line 118 "../src/plugins/vala-pack/ide-vala-locator.vala"
	g_return_if_fail (c != NULL);
#line 119 "../src/plugins/vala-pack/ide-vala-locator.vala"
	vala_code_node_accept_children ((ValaCodeNode*) c, (ValaCodeVisitor*) self);
#line 534 "ide-vala-locator.c"
}


static void
ide_vala_locator_real_visit_destructor (ValaCodeVisitor* base,
                                        ValaDestructor* d)
{
	IdeValaLocator * self;
#line 121 "../src/plugins/vala-pack/ide-vala-locator.vala"
	self = (IdeValaLocator*) base;
#line 121 "../src/plugins/vala-pack/ide-vala-locator.vala"
	g_return_if_fail (d != NULL);
#line 122 "../src/plugins/vala-pack/ide-vala-locator.vala"
	vala_code_node_accept_children ((ValaCodeNode*) d, (ValaCodeVisitor*) self);
#line 549 "ide-vala-locator.c"
}


static void
ide_vala_locator_real_visit_if_statement (ValaCodeVisitor* base,
                                          ValaIfStatement* stmt)
{
	IdeValaLocator * self;
#line 124 "../src/plugins/vala-pack/ide-vala-locator.vala"
	self = (IdeValaLocator*) base;
#line 124 "../src/plugins/vala-pack/ide-vala-locator.vala"
	g_return_if_fail (stmt != NULL);
#line 125 "../src/plugins/vala-pack/ide-vala-locator.vala"
	vala_code_node_accept_children ((ValaCodeNode*) stmt, (ValaCodeVisitor*) self);
#line 564 "ide-vala-locator.c"
}


static void
ide_vala_locator_real_visit_switch_statement (ValaCodeVisitor* base,
                                              ValaSwitchStatement* stmt)
{
	IdeValaLocator * self;
#line 127 "../src/plugins/vala-pack/ide-vala-locator.vala"
	self = (IdeValaLocator*) base;
#line 127 "../src/plugins/vala-pack/ide-vala-locator.vala"
	g_return_if_fail (stmt != NULL);
#line 128 "../src/plugins/vala-pack/ide-vala-locator.vala"
	vala_code_node_accept_children ((ValaCodeNode*) stmt, (ValaCodeVisitor*) self);
#line 579 "ide-vala-locator.c"
}


static void
ide_vala_locator_real_visit_switch_section (ValaCodeVisitor* base,
                                            ValaSwitchSection* section)
{
	IdeValaLocator * self;
#line 130 "../src/plugins/vala-pack/ide-vala-locator.vala"
	self = (IdeValaLocator*) base;
#line 130 "../src/plugins/vala-pack/ide-vala-locator.vala"
	g_return_if_fail (section != NULL);
#line 131 "../src/plugins/vala-pack/ide-vala-locator.vala"
	vala_code_visitor_visit_block ((ValaCodeVisitor*) self, (ValaBlock*) section);
#line 594 "ide-vala-locator.c"
}


static void
ide_vala_locator_real_visit_while_statement (ValaCodeVisitor* base,
                                             ValaWhileStatement* stmt)
{
	IdeValaLocator * self;
#line 133 "../src/plugins/vala-pack/ide-vala-locator.vala"
	self = (IdeValaLocator*) base;
#line 133 "../src/plugins/vala-pack/ide-vala-locator.vala"
	g_return_if_fail (stmt != NULL);
#line 134 "../src/plugins/vala-pack/ide-vala-locator.vala"
	vala_code_node_accept_children ((ValaCodeNode*) stmt, (ValaCodeVisitor*) self);
#line 609 "ide-vala-locator.c"
}


static void
ide_vala_locator_real_visit_do_statement (ValaCodeVisitor* base,
                                          ValaDoStatement* stmt)
{
	IdeValaLocator * self;
#line 136 "../src/plugins/vala-pack/ide-vala-locator.vala"
	self = (IdeValaLocator*) base;
#line 136 "../src/plugins/vala-pack/ide-vala-locator.vala"
	g_return_if_fail (stmt != NULL);
#line 137 "../src/plugins/vala-pack/ide-vala-locator.vala"
	vala_code_node_accept_children ((ValaCodeNode*) stmt, (ValaCodeVisitor*) self);
#line 624 "ide-vala-locator.c"
}


static void
ide_vala_locator_real_visit_for_statement (ValaCodeVisitor* base,
                                           ValaForStatement* stmt)
{
	IdeValaLocator * self;
#line 139 "../src/plugins/vala-pack/ide-vala-locator.vala"
	self = (IdeValaLocator*) base;
#line 139 "../src/plugins/vala-pack/ide-vala-locator.vala"
	g_return_if_fail (stmt != NULL);
#line 140 "../src/plugins/vala-pack/ide-vala-locator.vala"
	vala_code_node_accept_children ((ValaCodeNode*) stmt, (ValaCodeVisitor*) self);
#line 639 "ide-vala-locator.c"
}


static void
ide_vala_locator_real_visit_foreach_statement (ValaCodeVisitor* base,
                                               ValaForeachStatement* stmt)
{
	IdeValaLocator * self;
#line 142 "../src/plugins/vala-pack/ide-vala-locator.vala"
	self = (IdeValaLocator*) base;
#line 142 "../src/plugins/vala-pack/ide-vala-locator.vala"
	g_return_if_fail (stmt != NULL);
#line 143 "../src/plugins/vala-pack/ide-vala-locator.vala"
	vala_code_node_accept_children ((ValaCodeNode*) stmt, (ValaCodeVisitor*) self);
#line 654 "ide-vala-locator.c"
}


static void
ide_vala_locator_real_visit_try_statement (ValaCodeVisitor* base,
                                           ValaTryStatement* stmt)
{
	IdeValaLocator * self;
#line 145 "../src/plugins/vala-pack/ide-vala-locator.vala"
	self = (IdeValaLocator*) base;
#line 145 "../src/plugins/vala-pack/ide-vala-locator.vala"
	g_return_if_fail (stmt != NULL);
#line 146 "../src/plugins/vala-pack/ide-vala-locator.vala"
	vala_code_node_accept_children ((ValaCodeNode*) stmt, (ValaCodeVisitor*) self);
#line 669 "ide-vala-locator.c"
}


static void
ide_vala_locator_real_visit_catch_clause (ValaCodeVisitor* base,
                                          ValaCatchClause* clause)
{
	IdeValaLocator * self;
#line 148 "../src/plugins/vala-pack/ide-vala-locator.vala"
	self = (IdeValaLocator*) base;
#line 148 "../src/plugins/vala-pack/ide-vala-locator.vala"
	g_return_if_fail (clause != NULL);
#line 149 "../src/plugins/vala-pack/ide-vala-locator.vala"
	vala_code_node_accept_children ((ValaCodeNode*) clause, (ValaCodeVisitor*) self);
#line 684 "ide-vala-locator.c"
}


static void
ide_vala_locator_real_visit_lock_statement (ValaCodeVisitor* base,
                                            ValaLockStatement* stmt)
{
	IdeValaLocator * self;
#line 151 "../src/plugins/vala-pack/ide-vala-locator.vala"
	self = (IdeValaLocator*) base;
#line 151 "../src/plugins/vala-pack/ide-vala-locator.vala"
	g_return_if_fail (stmt != NULL);
#line 152 "../src/plugins/vala-pack/ide-vala-locator.vala"
	vala_code_node_accept_children ((ValaCodeNode*) stmt, (ValaCodeVisitor*) self);
#line 699 "ide-vala-locator.c"
}


static void
ide_vala_locator_real_visit_expression_statement (ValaCodeVisitor* base,
                                                  ValaExpressionStatement* stmt)
{
	IdeValaLocator * self;
#line 154 "../src/plugins/vala-pack/ide-vala-locator.vala"
	self = (IdeValaLocator*) base;
#line 154 "../src/plugins/vala-pack/ide-vala-locator.vala"
	g_return_if_fail (stmt != NULL);
#line 155 "../src/plugins/vala-pack/ide-vala-locator.vala"
	vala_code_node_accept_children ((ValaCodeNode*) stmt, (ValaCodeVisitor*) self);
#line 714 "ide-vala-locator.c"
}


static void
ide_vala_locator_real_visit_declaration_statement (ValaCodeVisitor* base,
                                                   ValaDeclarationStatement* stmt)
{
	IdeValaLocator * self;
#line 157 "../src/plugins/vala-pack/ide-vala-locator.vala"
	self = (IdeValaLocator*) base;
#line 157 "../src/plugins/vala-pack/ide-vala-locator.vala"
	g_return_if_fail (stmt != NULL);
#line 158 "../src/plugins/vala-pack/ide-vala-locator.vala"
	vala_code_node_accept_children ((ValaCodeNode*) stmt, (ValaCodeVisitor*) self);
#line 729 "ide-vala-locator.c"
}


static void
ide_vala_locator_real_visit_local_variable (ValaCodeVisitor* base,
                                            ValaLocalVariable* variable)
{
	IdeValaLocator * self;
#line 160 "../src/plugins/vala-pack/ide-vala-locator.vala"
	self = (IdeValaLocator*) base;
#line 160 "../src/plugins/vala-pack/ide-vala-locator.vala"
	g_return_if_fail (variable != NULL);
#line 161 "../src/plugins/vala-pack/ide-vala-locator.vala"
	vala_code_node_accept_children ((ValaCodeNode*) variable, (ValaCodeVisitor*) self);
#line 744 "ide-vala-locator.c"
}


static void
ide_vala_locator_real_visit_end_full_expression (ValaCodeVisitor* base,
                                                 ValaExpression* expr)
{
	IdeValaLocator * self;
#line 163 "../src/plugins/vala-pack/ide-vala-locator.vala"
	self = (IdeValaLocator*) base;
#line 163 "../src/plugins/vala-pack/ide-vala-locator.vala"
	g_return_if_fail (expr != NULL);
#line 164 "../src/plugins/vala-pack/ide-vala-locator.vala"
	if (G_TYPE_CHECK_INSTANCE_TYPE (expr, VALA_TYPE_LAMBDA_EXPRESSION)) {
#line 759 "ide-vala-locator.c"
		ValaMethod* _tmp0_;
		ValaMethod* _tmp1_;
#line 165 "../src/plugins/vala-pack/ide-vala-locator.vala"
		_tmp0_ = vala_lambda_expression_get_method (G_TYPE_CHECK_INSTANCE_TYPE (expr, VALA_TYPE_LAMBDA_EXPRESSION) ? ((ValaLambdaExpression*) expr) : NULL);
#line 165 "../src/plugins/vala-pack/ide-vala-locator.vala"
		_tmp1_ = _tmp0_;
#line 165 "../src/plugins/vala-pack/ide-vala-locator.vala"
		vala_code_visitor_visit_method ((ValaCodeVisitor*) self, _tmp1_);
#line 768 "ide-vala-locator.c"
	}
#line 166 "../src/plugins/vala-pack/ide-vala-locator.vala"
	if (G_TYPE_CHECK_INSTANCE_TYPE (expr, VALA_TYPE_METHOD_CALL)) {
#line 772 "ide-vala-locator.c"
		{
			ValaList* _e_list = NULL;
			ValaList* _tmp2_;
			gint _e_size = 0;
			ValaList* _tmp3_;
			gint _tmp4_;
			gint _tmp5_;
			gint _e_index = 0;
#line 167 "../src/plugins/vala-pack/ide-vala-locator.vala"
			_tmp2_ = vala_method_call_get_argument_list (G_TYPE_CHECK_INSTANCE_TYPE (expr, VALA_TYPE_METHOD_CALL) ? ((ValaMethodCall*) expr) : NULL);
#line 167 "../src/plugins/vala-pack/ide-vala-locator.vala"
			_e_list = _tmp2_;
#line 167 "../src/plugins/vala-pack/ide-vala-locator.vala"
			_tmp3_ = _e_list;
#line 167 "../src/plugins/vala-pack/ide-vala-locator.vala"
			_tmp4_ = vala_collection_get_size ((ValaCollection*) _tmp3_);
#line 167 "../src/plugins/vala-pack/ide-vala-locator.vala"
			_tmp5_ = _tmp4_;
#line 167 "../src/plugins/vala-pack/ide-vala-locator.vala"
			_e_size = _tmp5_;
#line 167 "../src/plugins/vala-pack/ide-vala-locator.vala"
			_e_index = -1;
#line 167 "../src/plugins/vala-pack/ide-vala-locator.vala"
			while (TRUE) {
#line 797 "ide-vala-locator.c"
				gint _tmp6_;
				gint _tmp7_;
				gint _tmp8_;
				ValaExpression* e = NULL;
				ValaList* _tmp9_;
				gint _tmp10_;
				gpointer _tmp11_;
				ValaExpression* _tmp12_;
#line 167 "../src/plugins/vala-pack/ide-vala-locator.vala"
				_tmp6_ = _e_index;
#line 167 "../src/plugins/vala-pack/ide-vala-locator.vala"
				_e_index = _tmp6_ + 1;
#line 167 "../src/plugins/vala-pack/ide-vala-locator.vala"
				_tmp7_ = _e_index;
#line 167 "../src/plugins/vala-pack/ide-vala-locator.vala"
				_tmp8_ = _e_size;
#line 167 "../src/plugins/vala-pack/ide-vala-locator.vala"
				if (!(_tmp7_ < _tmp8_)) {
#line 167 "../src/plugins/vala-pack/ide-vala-locator.vala"
					break;
#line 818 "ide-vala-locator.c"
				}
#line 167 "../src/plugins/vala-pack/ide-vala-locator.vala"
				_tmp9_ = _e_list;
#line 167 "../src/plugins/vala-pack/ide-vala-locator.vala"
				_tmp10_ = _e_index;
#line 167 "../src/plugins/vala-pack/ide-vala-locator.vala"
				_tmp11_ = vala_list_get (_tmp9_, _tmp10_);
#line 167 "../src/plugins/vala-pack/ide-vala-locator.vala"
				e = (ValaExpression*) _tmp11_;
#line 168 "../src/plugins/vala-pack/ide-vala-locator.vala"
				_tmp12_ = e;
#line 168 "../src/plugins/vala-pack/ide-vala-locator.vala"
				vala_code_visitor_visit_expression ((ValaCodeVisitor*) self, _tmp12_);
#line 167 "../src/plugins/vala-pack/ide-vala-locator.vala"
				_vala_code_node_unref0 (e);
#line 834 "ide-vala-locator.c"
			}
#line 167 "../src/plugins/vala-pack/ide-vala-locator.vala"
			_vala_iterable_unref0 (_e_list);
#line 838 "ide-vala-locator.c"
		}
	}
}


static void
ide_vala_locator_real_visit_expression (ValaCodeVisitor* base,
                                        ValaExpression* expr)
{
	IdeValaLocator * self;
#line 172 "../src/plugins/vala-pack/ide-vala-locator.vala"
	self = (IdeValaLocator*) base;
#line 172 "../src/plugins/vala-pack/ide-vala-locator.vala"
	g_return_if_fail (expr != NULL);
#line 173 "../src/plugins/vala-pack/ide-vala-locator.vala"
	if (G_TYPE_CHECK_INSTANCE_TYPE (expr, VALA_TYPE_LAMBDA_EXPRESSION)) {
#line 855 "ide-vala-locator.c"
		ValaMethod* _tmp0_;
		ValaMethod* _tmp1_;
#line 174 "../src/plugins/vala-pack/ide-vala-locator.vala"
		_tmp0_ = vala_lambda_expression_get_method (G_TYPE_CHECK_INSTANCE_TYPE (expr, VALA_TYPE_LAMBDA_EXPRESSION) ? ((ValaLambdaExpression*) expr) : NULL);
#line 174 "../src/plugins/vala-pack/ide-vala-locator.vala"
		_tmp1_ = _tmp0_;
#line 174 "../src/plugins/vala-pack/ide-vala-locator.vala"
		vala_code_visitor_visit_method ((ValaCodeVisitor*) self, _tmp1_);
#line 864 "ide-vala-locator.c"
	}
#line 175 "../src/plugins/vala-pack/ide-vala-locator.vala"
	if (G_TYPE_CHECK_INSTANCE_TYPE (expr, VALA_TYPE_METHOD_CALL)) {
#line 868 "ide-vala-locator.c"
		{
			ValaList* _e_list = NULL;
			ValaList* _tmp2_;
			gint _e_size = 0;
			ValaList* _tmp3_;
			gint _tmp4_;
			gint _tmp5_;
			gint _e_index = 0;
#line 176 "../src/plugins/vala-pack/ide-vala-locator.vala"
			_tmp2_ = vala_method_call_get_argument_list (G_TYPE_CHECK_INSTANCE_TYPE (expr, VALA_TYPE_METHOD_CALL) ? ((ValaMethodCall*) expr) : NULL);
#line 176 "../src/plugins/vala-pack/ide-vala-locator.vala"
			_e_list = _tmp2_;
#line 176 "../src/plugins/vala-pack/ide-vala-locator.vala"
			_tmp3_ = _e_list;
#line 176 "../src/plugins/vala-pack/ide-vala-locator.vala"
			_tmp4_ = vala_collection_get_size ((ValaCollection*) _tmp3_);
#line 176 "../src/plugins/vala-pack/ide-vala-locator.vala"
			_tmp5_ = _tmp4_;
#line 176 "../src/plugins/vala-pack/ide-vala-locator.vala"
			_e_size = _tmp5_;
#line 176 "../src/plugins/vala-pack/ide-vala-locator.vala"
			_e_index = -1;
#line 176 "../src/plugins/vala-pack/ide-vala-locator.vala"
			while (TRUE) {
#line 893 "ide-vala-locator.c"
				gint _tmp6_;
				gint _tmp7_;
				gint _tmp8_;
				ValaExpression* e = NULL;
				ValaList* _tmp9_;
				gint _tmp10_;
				gpointer _tmp11_;
				ValaExpression* _tmp12_;
#line 176 "../src/plugins/vala-pack/ide-vala-locator.vala"
				_tmp6_ = _e_index;
#line 176 "../src/plugins/vala-pack/ide-vala-locator.vala"
				_e_index = _tmp6_ + 1;
#line 176 "../src/plugins/vala-pack/ide-vala-locator.vala"
				_tmp7_ = _e_index;
#line 176 "../src/plugins/vala-pack/ide-vala-locator.vala"
				_tmp8_ = _e_size;
#line 176 "../src/plugins/vala-pack/ide-vala-locator.vala"
				if (!(_tmp7_ < _tmp8_)) {
#line 176 "../src/plugins/vala-pack/ide-vala-locator.vala"
					break;
#line 914 "ide-vala-locator.c"
				}
#line 176 "../src/plugins/vala-pack/ide-vala-locator.vala"
				_tmp9_ = _e_list;
#line 176 "../src/plugins/vala-pack/ide-vala-locator.vala"
				_tmp10_ = _e_index;
#line 176 "../src/plugins/vala-pack/ide-vala-locator.vala"
				_tmp11_ = vala_list_get (_tmp9_, _tmp10_);
#line 176 "../src/plugins/vala-pack/ide-vala-locator.vala"
				e = (ValaExpression*) _tmp11_;
#line 177 "../src/plugins/vala-pack/ide-vala-locator.vala"
				_tmp12_ = e;
#line 177 "../src/plugins/vala-pack/ide-vala-locator.vala"
				vala_code_visitor_visit_expression ((ValaCodeVisitor*) self, _tmp12_);
#line 176 "../src/plugins/vala-pack/ide-vala-locator.vala"
				_vala_code_node_unref0 (e);
#line 930 "ide-vala-locator.c"
			}
#line 176 "../src/plugins/vala-pack/ide-vala-locator.vala"
			_vala_iterable_unref0 (_e_list);
#line 934 "ide-vala-locator.c"
		}
	}
}


IdeValaLocator*
ide_vala_locator_construct (GType object_type)
{
	IdeValaLocator* self = NULL;
#line 21 "../src/plugins/vala-pack/ide-vala-locator.vala"
	self = (IdeValaLocator*) vala_code_visitor_construct (object_type);
#line 21 "../src/plugins/vala-pack/ide-vala-locator.vala"
	return self;
#line 948 "ide-vala-locator.c"
}


IdeValaLocator*
ide_vala_locator_new (void)
{
#line 21 "../src/plugins/vala-pack/ide-vala-locator.vala"
	return ide_vala_locator_construct (IDE_TYPE_VALA_LOCATOR);
#line 957 "ide-vala-locator.c"
}


static void
ide_vala_locator_location_init (IdeValaLocatorLocation *self,
                                gint line,
                                gint column)
{
#line 26 "../src/plugins/vala-pack/ide-vala-locator.vala"
	memset (self, 0, sizeof (IdeValaLocatorLocation));
#line 27 "../src/plugins/vala-pack/ide-vala-locator.vala"
	(*self).line = line;
#line 28 "../src/plugins/vala-pack/ide-vala-locator.vala"
	(*self).column = column;
#line 972 "ide-vala-locator.c"
}


static gboolean
ide_vala_locator_location_inside (IdeValaLocatorLocation *self,
                                  ValaSourceReference* src)
{
	gboolean result = FALSE;
	IdeValaLocatorLocation begin = {0};
	ValaSourceLocation _tmp0_ = {0};
	ValaSourceLocation _tmp1_;
	gint _tmp2_;
	ValaSourceLocation _tmp3_ = {0};
	ValaSourceLocation _tmp4_;
	gint _tmp5_;
	IdeValaLocatorLocation end = {0};
	ValaSourceLocation _tmp6_ = {0};
	ValaSourceLocation _tmp7_;
	gint _tmp8_;
	ValaSourceLocation _tmp9_ = {0};
	ValaSourceLocation _tmp10_;
	gint _tmp11_;
	gboolean _tmp12_ = FALSE;
#line 31 "../src/plugins/vala-pack/ide-vala-locator.vala"
	g_return_val_if_fail (src != NULL, FALSE);
#line 32 "../src/plugins/vala-pack/ide-vala-locator.vala"
	vala_source_reference_get_begin (src, &_tmp0_);
#line 32 "../src/plugins/vala-pack/ide-vala-locator.vala"
	_tmp1_ = _tmp0_;
#line 32 "../src/plugins/vala-pack/ide-vala-locator.vala"
	_tmp2_ = _tmp1_.line;
#line 32 "../src/plugins/vala-pack/ide-vala-locator.vala"
	vala_source_reference_get_begin (src, &_tmp3_);
#line 32 "../src/plugins/vala-pack/ide-vala-locator.vala"
	_tmp4_ = _tmp3_;
#line 32 "../src/plugins/vala-pack/ide-vala-locator.vala"
	_tmp5_ = _tmp4_.column;
#line 32 "../src/plugins/vala-pack/ide-vala-locator.vala"
	ide_vala_locator_location_init (&begin, _tmp2_, _tmp5_);
#line 33 "../src/plugins/vala-pack/ide-vala-locator.vala"
	vala_source_reference_get_end (src, &_tmp6_);
#line 33 "../src/plugins/vala-pack/ide-vala-locator.vala"
	_tmp7_ = _tmp6_;
#line 33 "../src/plugins/vala-pack/ide-vala-locator.vala"
	_tmp8_ = _tmp7_.line;
#line 33 "../src/plugins/vala-pack/ide-vala-locator.vala"
	vala_source_reference_get_end (src, &_tmp9_);
#line 33 "../src/plugins/vala-pack/ide-vala-locator.vala"
	_tmp10_ = _tmp9_;
#line 33 "../src/plugins/vala-pack/ide-vala-locator.vala"
	_tmp11_ = _tmp10_.column;
#line 33 "../src/plugins/vala-pack/ide-vala-locator.vala"
	ide_vala_locator_location_init (&end, _tmp8_, _tmp11_);
#line 35 "../src/plugins/vala-pack/ide-vala-locator.vala"
	if (ide_vala_locator_location_before (&begin, &(*self))) {
#line 1028 "ide-vala-locator.c"
		IdeValaLocatorLocation _tmp13_;
#line 35 "../src/plugins/vala-pack/ide-vala-locator.vala"
		_tmp13_ = end;
#line 35 "../src/plugins/vala-pack/ide-vala-locator.vala"
		_tmp12_ = ide_vala_locator_location_before (&(*self), &_tmp13_);
#line 1034 "ide-vala-locator.c"
	} else {
#line 35 "../src/plugins/vala-pack/ide-vala-locator.vala"
		_tmp12_ = FALSE;
#line 1038 "ide-vala-locator.c"
	}
#line 35 "../src/plugins/vala-pack/ide-vala-locator.vala"
	result = _tmp12_;
#line 35 "../src/plugins/vala-pack/ide-vala-locator.vala"
	return result;
#line 1044 "ide-vala-locator.c"
}


static gboolean
ide_vala_locator_location_before (IdeValaLocatorLocation *self,
                                  IdeValaLocatorLocation* other)
{
	gboolean result = FALSE;
	gint _tmp0_;
	IdeValaLocatorLocation _tmp1_;
	gint _tmp2_;
#line 38 "../src/plugins/vala-pack/ide-vala-locator.vala"
	g_return_val_if_fail (other != NULL, FALSE);
#line 39 "../src/plugins/vala-pack/ide-vala-locator.vala"
	_tmp0_ = (*self).line;
#line 39 "../src/plugins/vala-pack/ide-vala-locator.vala"
	_tmp1_ = *other;
#line 39 "../src/plugins/vala-pack/ide-vala-locator.vala"
	_tmp2_ = _tmp1_.line;
#line 39 "../src/plugins/vala-pack/ide-vala-locator.vala"
	if (_tmp0_ > _tmp2_) {
#line 40 "../src/plugins/vala-pack/ide-vala-locator.vala"
		result = FALSE;
#line 40 "../src/plugins/vala-pack/ide-vala-locator.vala"
		return result;
#line 1070 "ide-vala-locator.c"
	} else {
		gboolean _tmp3_ = FALSE;
		gint _tmp4_;
		IdeValaLocatorLocation _tmp5_;
		gint _tmp6_;
#line 41 "../src/plugins/vala-pack/ide-vala-locator.vala"
		_tmp4_ = (*self).line;
#line 41 "../src/plugins/vala-pack/ide-vala-locator.vala"
		_tmp5_ = *other;
#line 41 "../src/plugins/vala-pack/ide-vala-locator.vala"
		_tmp6_ = _tmp5_.line;
#line 41 "../src/plugins/vala-pack/ide-vala-locator.vala"
		if (_tmp4_ == _tmp6_) {
#line 1084 "ide-vala-locator.c"
			gint _tmp7_;
			IdeValaLocatorLocation _tmp8_;
			gint _tmp9_;
#line 41 "../src/plugins/vala-pack/ide-vala-locator.vala"
			_tmp7_ = (*self).column;
#line 41 "../src/plugins/vala-pack/ide-vala-locator.vala"
			_tmp8_ = *other;
#line 41 "../src/plugins/vala-pack/ide-vala-locator.vala"
			_tmp9_ = _tmp8_.column;
#line 41 "../src/plugins/vala-pack/ide-vala-locator.vala"
			_tmp3_ = _tmp7_ > _tmp9_;
#line 1096 "ide-vala-locator.c"
		} else {
#line 41 "../src/plugins/vala-pack/ide-vala-locator.vala"
			_tmp3_ = FALSE;
#line 1100 "ide-vala-locator.c"
		}
#line 41 "../src/plugins/vala-pack/ide-vala-locator.vala"
		if (_tmp3_) {
#line 42 "../src/plugins/vala-pack/ide-vala-locator.vala"
			result = FALSE;
#line 42 "../src/plugins/vala-pack/ide-vala-locator.vala"
			return result;
#line 1108 "ide-vala-locator.c"
		}
	}
#line 43 "../src/plugins/vala-pack/ide-vala-locator.vala"
	result = TRUE;
#line 43 "../src/plugins/vala-pack/ide-vala-locator.vala"
	return result;
#line 1115 "ide-vala-locator.c"
}


static IdeValaLocatorLocation*
ide_vala_locator_location_dup (const IdeValaLocatorLocation* self)
{
	IdeValaLocatorLocation* dup;
#line 22 "../src/plugins/vala-pack/ide-vala-locator.vala"
	dup = g_new0 (IdeValaLocatorLocation, 1);
#line 22 "../src/plugins/vala-pack/ide-vala-locator.vala"
	memcpy (dup, self, sizeof (IdeValaLocatorLocation));
#line 22 "../src/plugins/vala-pack/ide-vala-locator.vala"
	return dup;
#line 1129 "ide-vala-locator.c"
}


static void
ide_vala_locator_location_free (IdeValaLocatorLocation* self)
{
#line 22 "../src/plugins/vala-pack/ide-vala-locator.vala"
	g_free (self);
#line 1138 "ide-vala-locator.c"
}


static GType
ide_vala_locator_location_get_type (void)
{
	static volatile gsize ide_vala_locator_location_type_id__volatile = 0;
	if (g_once_init_enter (&ide_vala_locator_location_type_id__volatile)) {
		GType ide_vala_locator_location_type_id;
		ide_vala_locator_location_type_id = g_boxed_type_register_static ("IdeValaLocatorLocation", (GBoxedCopyFunc) ide_vala_locator_location_dup, (GBoxedFreeFunc) ide_vala_locator_location_free);
		g_once_init_leave (&ide_vala_locator_location_type_id__volatile, ide_vala_locator_location_type_id);
	}
	return ide_vala_locator_location_type_id__volatile;
}


static void
ide_vala_locator_class_init (IdeValaLocatorClass * klass)
{
#line 21 "../src/plugins/vala-pack/ide-vala-locator.vala"
	ide_vala_locator_parent_class = g_type_class_peek_parent (klass);
#line 21 "../src/plugins/vala-pack/ide-vala-locator.vala"
	((ValaCodeVisitorClass *) klass)->finalize = ide_vala_locator_finalize;
#line 21 "../src/plugins/vala-pack/ide-vala-locator.vala"
	g_type_class_adjust_private_offset (klass, &IdeValaLocator_private_offset);
#line 21 "../src/plugins/vala-pack/ide-vala-locator.vala"
	((ValaCodeVisitorClass *) klass)->visit_block = (void (*) (ValaCodeVisitor *, ValaBlock*)) ide_vala_locator_real_visit_block;
#line 21 "../src/plugins/vala-pack/ide-vala-locator.vala"
	((ValaCodeVisitorClass *) klass)->visit_namespace = (void (*) (ValaCodeVisitor *, ValaNamespace*)) ide_vala_locator_real_visit_namespace;
#line 21 "../src/plugins/vala-pack/ide-vala-locator.vala"
	((ValaCodeVisitorClass *) klass)->visit_class = (void (*) (ValaCodeVisitor *, ValaClass*)) ide_vala_locator_real_visit_class;
#line 21 "../src/plugins/vala-pack/ide-vala-locator.vala"
	((ValaCodeVisitorClass *) klass)->visit_struct = (void (*) (ValaCodeVisitor *, ValaStruct*)) ide_vala_locator_real_visit_struct;
#line 21 "../src/plugins/vala-pack/ide-vala-locator.vala"
	((ValaCodeVisitorClass *) klass)->visit_interface = (void (*) (ValaCodeVisitor *, ValaInterface*)) ide_vala_locator_real_visit_interface;
#line 21 "../src/plugins/vala-pack/ide-vala-locator.vala"
	((ValaCodeVisitorClass *) klass)->visit_method = (void (*) (ValaCodeVisitor *, ValaMethod*)) ide_vala_locator_real_visit_method;
#line 21 "../src/plugins/vala-pack/ide-vala-locator.vala"
	((ValaCodeVisitorClass *) klass)->visit_creation_method = (void (*) (ValaCodeVisitor *, ValaCreationMethod*)) ide_vala_locator_real_visit_creation_method;
#line 21 "../src/plugins/vala-pack/ide-vala-locator.vala"
	((ValaCodeVisitorClass *) klass)->visit_property = (void (*) (ValaCodeVisitor *, ValaProperty*)) ide_vala_locator_real_visit_property;
#line 21 "../src/plugins/vala-pack/ide-vala-locator.vala"
	((ValaCodeVisitorClass *) klass)->visit_property_accessor = (void (*) (ValaCodeVisitor *, ValaPropertyAccessor*)) ide_vala_locator_real_visit_property_accessor;
#line 21 "../src/plugins/vala-pack/ide-vala-locator.vala"
	((ValaCodeVisitorClass *) klass)->visit_constructor = (void (*) (ValaCodeVisitor *, ValaConstructor*)) ide_vala_locator_real_visit_constructor;
#line 21 "../src/plugins/vala-pack/ide-vala-locator.vala"
	((ValaCodeVisitorClass *) klass)->visit_destructor = (void (*) (ValaCodeVisitor *, ValaDestructor*)) ide_vala_locator_real_visit_destructor;
#line 21 "../src/plugins/vala-pack/ide-vala-locator.vala"
	((ValaCodeVisitorClass *) klass)->visit_if_statement = (void (*) (ValaCodeVisitor *, ValaIfStatement*)) ide_vala_locator_real_visit_if_statement;
#line 21 "../src/plugins/vala-pack/ide-vala-locator.vala"
	((ValaCodeVisitorClass *) klass)->visit_switch_statement = (void (*) (ValaCodeVisitor *, ValaSwitchStatement*)) ide_vala_locator_real_visit_switch_statement;
#line 21 "../src/plugins/vala-pack/ide-vala-locator.vala"
	((ValaCodeVisitorClass *) klass)->visit_switch_section = (void (*) (ValaCodeVisitor *, ValaSwitchSection*)) ide_vala_locator_real_visit_switch_section;
#line 21 "../src/plugins/vala-pack/ide-vala-locator.vala"
	((ValaCodeVisitorClass *) klass)->visit_while_statement = (void (*) (ValaCodeVisitor *, ValaWhileStatement*)) ide_vala_locator_real_visit_while_statement;
#line 21 "../src/plugins/vala-pack/ide-vala-locator.vala"
	((ValaCodeVisitorClass *) klass)->visit_do_statement = (void (*) (ValaCodeVisitor *, ValaDoStatement*)) ide_vala_locator_real_visit_do_statement;
#line 21 "../src/plugins/vala-pack/ide-vala-locator.vala"
	((ValaCodeVisitorClass *) klass)->visit_for_statement = (void (*) (ValaCodeVisitor *, ValaForStatement*)) ide_vala_locator_real_visit_for_statement;
#line 21 "../src/plugins/vala-pack/ide-vala-locator.vala"
	((ValaCodeVisitorClass *) klass)->visit_foreach_statement = (void (*) (ValaCodeVisitor *, ValaForeachStatement*)) ide_vala_locator_real_visit_foreach_statement;
#line 21 "../src/plugins/vala-pack/ide-vala-locator.vala"
	((ValaCodeVisitorClass *) klass)->visit_try_statement = (void (*) (ValaCodeVisitor *, ValaTryStatement*)) ide_vala_locator_real_visit_try_statement;
#line 21 "../src/plugins/vala-pack/ide-vala-locator.vala"
	((ValaCodeVisitorClass *) klass)->visit_catch_clause = (void (*) (ValaCodeVisitor *, ValaCatchClause*)) ide_vala_locator_real_visit_catch_clause;
#line 21 "../src/plugins/vala-pack/ide-vala-locator.vala"
	((ValaCodeVisitorClass *) klass)->visit_lock_statement = (void (*) (ValaCodeVisitor *, ValaLockStatement*)) ide_vala_locator_real_visit_lock_statement;
#line 21 "../src/plugins/vala-pack/ide-vala-locator.vala"
	((ValaCodeVisitorClass *) klass)->visit_expression_statement = (void (*) (ValaCodeVisitor *, ValaExpressionStatement*)) ide_vala_locator_real_visit_expression_statement;
#line 21 "../src/plugins/vala-pack/ide-vala-locator.vala"
	((ValaCodeVisitorClass *) klass)->visit_declaration_statement = (void (*) (ValaCodeVisitor *, ValaDeclarationStatement*)) ide_vala_locator_real_visit_declaration_statement;
#line 21 "../src/plugins/vala-pack/ide-vala-locator.vala"
	((ValaCodeVisitorClass *) klass)->visit_local_variable = (void (*) (ValaCodeVisitor *, ValaLocalVariable*)) ide_vala_locator_real_visit_local_variable;
#line 21 "../src/plugins/vala-pack/ide-vala-locator.vala"
	((ValaCodeVisitorClass *) klass)->visit_end_full_expression = (void (*) (ValaCodeVisitor *, ValaExpression*)) ide_vala_locator_real_visit_end_full_expression;
#line 21 "../src/plugins/vala-pack/ide-vala-locator.vala"
	((ValaCodeVisitorClass *) klass)->visit_expression = (void (*) (ValaCodeVisitor *, ValaExpression*)) ide_vala_locator_real_visit_expression;
#line 1216 "ide-vala-locator.c"
}


static void
ide_vala_locator_instance_init (IdeValaLocator * self)
{
#line 21 "../src/plugins/vala-pack/ide-vala-locator.vala"
	self->priv = ide_vala_locator_get_instance_private (self);
#line 1225 "ide-vala-locator.c"
}


static void
ide_vala_locator_finalize (ValaCodeVisitor * obj)
{
	IdeValaLocator * self;
#line 21 "../src/plugins/vala-pack/ide-vala-locator.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, IDE_TYPE_VALA_LOCATOR, IdeValaLocator);
#line 48 "../src/plugins/vala-pack/ide-vala-locator.vala"
	_vala_code_node_unref0 (self->priv->innermost);
#line 21 "../src/plugins/vala-pack/ide-vala-locator.vala"
	VALA_CODE_VISITOR_CLASS (ide_vala_locator_parent_class)->finalize (obj);
#line 1239 "ide-vala-locator.c"
}


GType
ide_vala_locator_get_type (void)
{
	return ide_vala_locator_type_id;
}


GType
ide_vala_locator_register_type (GTypeModule * module)
{
	static const GTypeInfo g_define_type_info = { sizeof (IdeValaLocatorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) ide_vala_locator_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (IdeValaLocator), 0, (GInstanceInitFunc) ide_vala_locator_instance_init, NULL };
	ide_vala_locator_type_id = g_type_module_register_type (module, VALA_TYPE_CODE_VISITOR, "IdeValaLocator", &g_define_type_info, 0);
	IdeValaLocator_private_offset = sizeof (IdeValaLocatorPrivate);
	return ide_vala_locator_type_id;
}



